import { Injectable } from '@angular/core';
import { DiscoverHost, Zone } from '@overflow/model/discovery';
import { Observable, BehaviorSubject } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class DiscoveryConfigService {


  private discoverHostSubject = new BehaviorSubject<DiscoverHost>(null);
  private zoneSubject = new BehaviorSubject<Zone>(null);
  private startSubject = new BehaviorSubject<boolean>(false);

  discoverHost: Observable<DiscoverHost>;
  zone: Observable<Zone>;
  started: Observable<boolean>;


  constructor() {
    this.discoverHost = this.discoverHostSubject.asObservable();
    this.zone = this.zoneSubject.asObservable();
    this.started = this.startSubject.asObservable();
  }

  public setZone(zone: Zone): void {
    this.zoneSubject.next(zone);
  }

  public setDiscoverHost(discoverHost: DiscoverHost): void {
    this.discoverHostSubject.next(discoverHost);
  }

  public setStarted(isStarted: boolean): void {
    this.startSubject.next(isStarted);
  }

}
